# ----------------------------------------------------------------------------
#         ATMEL Microcontroller Software Support 
# ----------------------------------------------------------------------------
# Copyright (c) 2011, Atmel Corporation
#
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# - Redistributions of source code must retain the above copyright notice,
# this list of conditions and the disclaimer below.
#
# Atmel's name may not be used to endorse or promote products derived from
# this software without specific prior written permission.
#
# DISCLAIMER: THIS SOFTWARE IS PROVIDED BY ATMEL "AS IS" AND ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT ARE
# DISCLAIMED. IN NO EVENT SHALL ATMEL BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
# OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
# EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# ----------------------------------------------------------------------------

################################################################################
#  Main script: Do commands
################################################################################

puts [lindex $argv 0]
puts [lindex $argv 1]
puts [lindex $argv 2]
puts [lindex $argv 3]
if {$argc < 4} {
    puts "-E- Expecting BIM file name as argument to script"
    exit
}
# Note: Use relative file path for binfile, which must live in the batch file directory:
set binfile [lindex $argv 3]

puts "-I- Enable Flash Access"
FLASH::Init 0 

puts "-I- Erase Flash"
if { [ FLASH::EraseAll ] != 1 } {
    puts "-E- Unable to erase flash (lock bits?)"
    exit
}

#puts "-I- Boot from Flash (GPNVM1)"
#FLASH::ScriptGPNMV 2

puts "-I- Sending File $binfile"
send_file {Flash 0} $binfile 0x80000 0

puts "-I- Boot from Flash (GPNVM1)"
FLASH::ScriptGPNMV 2

# reset device
puts "-I- Resetting device!"
TCL_Write_Int $target(handle) 0xA5000001 0x400E1200

exit

